require "Window"
local ViragsTabOnlyHostile = {} 

function ViragsTabOnlyHostile:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
	self.ktUnitDB = {}
    return o
end

function ViragsTabOnlyHostile:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end

function ViragsTabOnlyHostile:OnLoad()
	Apollo.RegisterEventHandler("SystemKeyDown", 				"OnSystemKeyDown", self)
	Apollo.RegisterEventHandler("UnitCreated", 					"OnUnitCreated", self)
	Apollo.RegisterEventHandler("UnitDestroyed", 				"OnUnitDestroyed", self)
	Apollo.RegisterEventHandler("TargetUnitChanged", 			"OnTargetUnitChanged", self)
	Apollo.RegisterTimerHandler("ViragsTargetWait", 		"OnWait", self)
	Apollo.CreateTimer("ViragsTargetWait", 0.1, false)
	Apollo.StopTimer("ViragsTargetWait")
end

function ViragsTabOnlyHostile:OnUnitCreated(unitNew) 
	if	unitNew:GetHealth() ~= nil then
		self.ktUnitDB[unitNew:GetId()] = unitNew 
	end  
end

function ViragsTabOnlyHostile:OnUnitDestroyed(unitOwner)
 	self.ktUnitDB[unitOwner:GetId()] = nil       
end

function ViragsTabOnlyHostile:OnSystemKeyDown(iKey)      
	if iKey == 9 then self.bTabPressed = true end
end

function ViragsTabOnlyHostile:OnTargetUnitChanged(newTarget)
	
	if self.bTabPressed then 
		local player = GameLib.GetPlayerUnit()
		self.bTabPressed = false
		if player and newTarget and Unit.CodeEnumDisposition.Hostile ~= newTarget:GetDispositionTo(player) then
			for k,v in pairs(self.ktUnitDB) do
				if v:GetDispositionTo(player) == Unit.CodeEnumDisposition.Hostile and v:IsInCombat() then
					local targetFrame= Apollo.GetAddon("TargetFrame")
					Apollo.RemoveEventHandler("TargetUnitChanged", targetFrame)
				 	GameLib.SetTargetUnit(v)
					Apollo.StartTimer("ViragsTargetWait")
					return
				 end
			end
		end		
	end	
end

function ViragsTabOnlyHostile:OnWait()
	local targetFrame= Apollo.GetAddon("TargetFrame")
	Apollo.RegisterEventHandler("TargetUnitChanged", "OnTargetUnitChanged", targetFrame)
end

local ViragsTabOnlyHostileInst = ViragsTabOnlyHostile:new()
ViragsTabOnlyHostileInst:Init()
